
/* prob2r.c						*/
/* program for LCAU24 option 't'			*/
/* calculate probabilities related to evolution		*/
/* generic portion of probkr.c which applies to binary  */
/* automata and which does not make any explicit use of */
/* the neighborhood size. It is to be included in each  */
/* specific prob2r file.				*/
/* Harold V. McIntosh, 20 January 1992			*/

/*  Copyright (C) 1992  */
/*  Harold V. McIntosh  */

/* ---------------------------------------------------- */

/* change mils to floating */
double mq(n) int n; {return (0.001*((double)n));}

/* change keyboard mils to floating */
double smq() {return (0.001*((double)numin(0)));}

/* clear panels on the screen */
clep(c) char c; {switch (c) {
case 'x': videoscroll(EROW,0,24,39,0,0); break;
case 'e': videoscroll(EROW,0,EROW+1,39,0,0); break;
case 'm': videoscroll(BROW,0,BROW+8,39,0,0); break;
case 'a': videoscroll(GROW,0,24,12,0,0); break;
case 'b': videoscroll(GROW,13,24,26,0,0); break;
case 'c': videoscroll(GROW,27,24,39,0,0); break;
default: break;}}

/* show menu */
trmenu() {
  videoscroll(BROW,0,BROW+8,40,0,0);
  videocursor(0,BROW,0);
  printf("a,h     - a priori estimates, entropy\n");
  printf("m,M,g,G - sample evolution\n");
  printf("xy      - selfconsistent probabilities\n");
  printf("xij     - iterated s-c probabilities\n");
  printf("t       - graph 2 block probabilities\n");
  printf("123456  - n-block bar charts\n");
  printf("+-      - change color pallette\n");
  printf("e       - 12 lines evolution\n");
  printf("/?(clear screen, show menu), <cr>(exit)\n");
}

/* menu of parameter values */
prmenu() {
  videoscroll(BROW,0,BROW+8,40,0,0);
  videocursor(0,BROW,0);
  tidat();
  printf(" AL = %6d: ring length  \n",AL);
  printf(" mf = %6.3f: m increment  (MOA,MOB)\n",mf);
  printf(" bi = %6d: bernstein index    (I)\n",bi);
  printf(" bx = %6.3f: b factor mils      (X)\n",bx[bi]);
  printf(" pl = %6d: line freq 1's mils (B)\n",pl);
  printf(" pr = %6d: rule freq 1's mils (F)\n",pr);
  switch (dn) {
    case 1: switch (co) {
      case 0: printf(" co =      0: fully random       (o)\n"); break;
      case 1: printf(" co =      1: normal             (o)\n"); break;
      case 2: printf(" co =      2: random pairs       (o)\n"); break;
      case 3: printf(" co =      3: random triples     (o)\n"); break;
      case 4: printf(" co =      4: random quadruples  (o)\n"); break;
      case 5: printf(" co =      5: random w 1/8 pairs (o)\n"); break;
      case 6: printf(" co =      6: random w 1/16 prs  (o)\n"); break;
      default: break;} break;
    case 2: printf(" dn =      2: two dimensional  M (O)\n"); break;
    case 3: printf(" dn =      3: three dimensional  (O)\n"); break;
    case 4: printf(" dn =      4: four dimensional   (O)\n"); break;
    case 5: printf(" dn =      5: five dimensional   (O)\n"); break;
    case 6: printf(" dn =      6: six dimensional    (O)\n"); break;
    case 7: printf(" dn =      7: two dimensional vN (O)\n"); break;
    default: break;}
}

/* show twelve lines of evolution at top of screen */
pevolve() {int i, j;
  videoscroll(EROW,0,EROW+1,40,0,0);
  asctobin();
  for (j=8*EROW; j<8*(EROW+2)-3; j++) {
    for (i=0; i<YL; i++) videodot(j,i,arr1[i]);
    onegen(AL);
    if (kbdst()) {kbdin(); break;}
    }
}

/* put a dot in column n on the top margin of panel C, color l */

gbmar(n,l) int n, l; {videodot(199-(n*100)/(TS-1),CORG+99,l);}

/* make a frame for a graph 		 */
/* (x,y) = lower left corner; e.g. (0,0) */
/* n     = dimension of frame            */
/* l     = color of frame		 */

gfram(x,y,n,l) int x, y, n, l; {int i;

for (i=0; i<=n; i++) videodot(199-y-i,x,0);
for (i=0; i<=n; i++) videodot(199-y-i,x+n,0);
for (i=0; i<=n; i++) videodot(199-n-y,x+i,0);
for (i=0; i<=n; i++) videodot(199-y,x+i,0);

for (i=0; i<=n; i+=10) videodot(199-y-i,x,l);
for (i=0; i<=n; i+=10) videodot(199-y-i,x+n,l);
for (i=0; i<=n; i+=10) videodot(199-n-y,x+i,l);
for (i=0; i<=n; i+=10) videodot(199-y,x+i,l);
}

/* put a diagonal in a graph in color l */

gdiag(x,y,n,l) int x, y, n, l; {int i;
for (i=0; i<=n; i+=2) videodot(199-y-i,x+i,l);
}

/* place a graph of w=z*z at location x,y in color l */

guare(x,y,n,l) int x, y, n, l; {int i;
for (i=0; i<=n; i+=2) videodot(199-y-i,x+(i*i)/n,l);
}

/* graph entropy as a function of p	*/
/* (x,y) origin of graph		*/
/* n     number of points		*/

egraf(x,y,n) int x, y, n; {int i; double em, en, p, q, t;
em=100.0/log((double)KK);
en=1.0/(double)(n);
for (i=0; i<n; i++) {
  p=((double)(i))*en; q=1.0-p;
  t=p*log(p)+q*log(q);
  videodot(199-y-i,x+((int)(-t*em)),1);
  };
}

/* graph Bernstein polynomial */

bgraf(x,y,k,n) int x, y, k, n; {int i; double bern(), en, dp, p;
if (n==0) return;
en=(double)(n); dp=1.0/en;
for (i=0,p=0.0; i<n; i++,p+=dp) {videodot(199-y-i,x+(int)(en*bern(p,k)),1);}
}

/* graph cummulative probabilities for n steps in color l */

cgraf(n,l) int n, l; {int i, j, fr, cp[101]; double s, ff;
if (n==0) return;
s=100.0/((double)AL);
asctobin();
for (i=0; i<101; i++) cp[i]=0;
for (i=0; i<n; i++) {
  for (fr=0, j=0; j<AL; j++) if (arr1[j]==1) fr++;
  ff=(double)fr;
  fr=(int)(s*ff);
  if (cp[fr]<101) cp[fr]++;
  videodot(199-fr,AORG+cp[fr],(l==0?(i%2)+1:l));
  if (kbdst()) {kbdin(); break;}
  onegen(AL);
  }
}

/* show the Bernstein coefficients */

bcprin() {int i; double en;
clep('m');
en=1.0/((double)DS);
videocursor(0,BROW+6,0);
for (i=0; i<5; i++) printf("%1d:%5.3f ",i,en*bp[i]);
videocursor(0,BROW+7,0);
for (i=5; i<TS; i++) printf("%1d:%5.3f ",i,en*bp[i]);
}

/* find fixed points of a parabola from three points */

parfix() {
int    i;
double a, b, c, fa, fb, fc;
double aa, bb, cc;

a=smq();
b=smq();
c=smq();
fa=smq();
fb=smq();
fc=smq();

clep('m');
videocursor(0,BROW+1,0); printf("%6.3f, %6.3f, %6.3f",a,b,c);
videocursor(0,BROW+2,0); printf("%6.3f, %6.3f, %6.3f",fa,fb,fc);
aa=fa/((a-b)*(a-c))+fb/((b-a)*(b-c))+fc/((c-a)*(c-b));
bb=(fa*(b+c))/((a-b)*(a-c))+(fb*(a+c))/((b-a)*(b-c))+(fc*(a+b))/((c-a)*(c-b));
bb=-bb;
cc=(fa*b*c)/((a-b)*(a-c))+(fb*a*c)/((b-a)*(b-c))+(fc*a*b)/((c-a)*(c-b));
grap(aa,bb,cc);
}

/* graph a parabola given its coefficients */

grap(aa,bb,cc) double aa, bb, cc; {
int    i;
double dd, rp, rm;
double hp, lp, uu, mu, en, dp;
double p, y;

videocursor(0,BROW+7,0); printf("aa = %6.3f, bb = %6.3f, cc = %6.3f",aa,bb,cc);
bb-=1.0;
dd=bb*bb-4.0*aa*cc;
dd=sqrt(dd);
rp=(-bb+dd)/(2.0*aa);
rm=(-bb-dd)/(2.0*aa);
bb+=1.0;
fpa=lp=(rp<=rm?rp:rm);
fpb=hp=(rp<=rm?rm:rp);
mu=2.0*aa*lp+bb;
videocursor(0,BROW+8,0); printf("lp = %6.3f, hp = %6.3f",lp,hp);
videocursor(0,BROW+6,0); printf("mu = %6.3f, sl = %6.3f, 2d = %6.3f",mu,2.0-mu,-2.0*mu);
fpc=uu=hp-1.0/aa;
en=101.0; dp=(uu-lp)/en;
for (i=0, p=lp; i<101; i++, p+=dp) {
  y=(aa*p+bb)*p+cc;
  videodot(199-(int)(en*p),CORG+(int)(en*y),1);
  }
}

/* option L - least squares parabola fitting return map */

lesq(n,l) int n, l; {
int    i, j, ns;
double det3();
double mi[5][5], mx[5][5], mp[5][5];
double aa, bb, cc, dd, ee, ff;
double of, nf, s, p, y, dp, en;
double o2, o3, o4, o5, o6, o7, o8;
double p1, p2, p3, p4;
double m0, m1, m2, m3, m4, m5, m6, m7, m8;
double y0, y1, y2, y3, y4;

  clep('m');
  s=1.0/((double)AL);
  m0=m1=m2=m3=m4=m5=m6=m7=m8=0.0;
  y0=y1=y2=y3=y4=0.0;
  asctobin();
  onegen(AL);
  for (ns=0, j=0; j<AL; j++) if (arr1[j]==1) ns++;
  nf=s*((double)ns);
  for (i=0; i<n; i++) {
    of=nf;
    onegen(AL);
    for (ns=0, j=0; j<AL; j++) if (arr1[j]==1) ns++;
    nf=s*((double)ns);
    o2=of*of; o3=o2*of; o4=o3*of; o5=o4*of; o6=o5*of; o7=o6*of; o8=o7*of;
    p1=nf*of; p2=p1*of; p3=p2*of; p4=p3*of;
    m0+=1.0; m1+=of; m2+=o2; m3+=o3; m4+=o4; m5+=o5; m6+=o6; m7+=o7; m8+=o8;
    y0+=nf; y1+=p1; y2+=p2; y3+=p3; y4+=p4;
    videodot(199-(int)(100.0*of),CORG+(int)(100.0*nf),l);
    if (kbdst()) {kbdin(); break;}
    }
  m1/=m0; m2/=m0; m3/=m0; m4/=m0; m5/=m0; m6/=m0; m7/=m0; m8/=m0;
  y0/=m0; y1/=m0; y2/=m0; y3/=m0; y4/=m0;
  m0/=m0;
  aa=det3(m0,m1,m2,m1,m2,m3,y0,y1,y2);
  bb=det3(m0,m1,m2,y0,y1,y2,m2,m3,m4);
  cc=det3(y0,y1,y2,m1,m2,m3,m2,m3,m4);
  dd=det3(m0,m1,m2,m1,m2,m3,m2,m3,m4);
  aa/=dd; bb/=dd; cc/=dd;
  grap(aa,bb,cc);
  mx[0][0]=m0; mx[0][1]=m1; mx[0][2]=m2; mx[0][3]=m3; mx[0][4]=m4;
  mx[1][0]=m1; mx[1][1]=m2; mx[1][2]=m3; mx[1][3]=m4; mx[1][4]=m5;
  mx[2][0]=m2; mx[2][1]=m3; mx[2][2]=m4; mx[2][3]=m5; mx[2][4]=m6;
  mx[3][0]=m3; mx[3][1]=m4; mx[3][2]=m5; mx[3][3]=m6; mx[3][4]=m7;
  mx[4][0]=m4; mx[4][1]=m5; mx[4][2]=m6; mx[4][3]=m7; mx[4][4]=m8;
  matmi5(mi,mx);
    for (i=0; i<6; i++) {
      matmp5(mp,mx,mi);
      matome5(mp,mp);
      matmp5(mi,mi,mp);  
      }
  pv[0]=mi[0][0]*y0+mi[0][1]*y1+mi[0][2]*y2+mi[0][3]*y3+mi[0][4]*y4;
  pv[1]=mi[1][0]*y0+mi[1][1]*y1+mi[1][2]*y2+mi[1][3]*y3+mi[1][4]*y4;
  pv[2]=mi[2][0]*y0+mi[2][1]*y1+mi[2][2]*y2+mi[2][3]*y3+mi[2][4]*y4;
  pv[3]=mi[3][0]*y0+mi[3][1]*y1+mi[3][2]*y2+mi[3][3]*y3+mi[3][4]*y4;
  pv[4]=mi[4][0]*y0+mi[4][1]*y1+mi[4][2]*y2+mi[4][3]*y3+mi[4][4]*y4;
  y0=fpb; y1=y0*fpb; y2=y1*fpb; y3=y2*fpb;
  aa=pv[4];
  bb=pv[3]+4.0*pv[4]*y0;
  cc=pv[2]+3.0*pv[3]*y0+6.0*pv[4]*y1;
  dd=pv[1]+2.0*pv[2]*y0+3.0*pv[3]*y1+4.0*pv[4]*y2;
  ee=pv[0]+    pv[1]*y0+    pv[2]*y1+    pv[3]*y2+    pv[4]*y3-    fpb;
videocursor(0,BROW+1,0); printf("aa = %6.3f, bb = %6.3f, cc = %6.3f",aa,bb,cc);
videocursor(0,BROW+2,0); printf("dd = %6.3f, ee = %6.3f",dd,ee);
en=101.0; dp=(fpc-fpa)/en;
for (i=0, p=fpa; i<101; i++, p+=dp) {
  y=(((pv[4]*p+pv[3])*p+pv[2])*p+pv[1])*p+pv[0];
  videodot(199-(int)(en*p),CORG+(int)(en*y),2);
  }
}

/* evaluate 3x3 determinant */
double det3(a,b,c,d,e,f,g,h,i) double a, b, c, d, e, f, g, h, i; {
return (a*(e*i-f*h)+b*(f*g-d*i)+c*(d*h-g*e));}

/* matmi5 - 5x5 matrix inverse */

matmi5(z,u) double z[5][5], u[5][5]; {
int    i, j, n, ii[5], matge5();
double f, w[5][5];
n=5;
matcm5(w,u);
matum5(z);
for (i=0; i<n; i++) {
  ii[i]=matge5(w,i);
  matxr5(w,i,ii[i]);
  for (j=0; j<n; j++) {
    if (i==j) continue;
    f=-w[i][j]/w[i][i];
    matac5(w,j,j,f,i);
    matac5(z,j,j,f,i);
    }
  }
for (i=0; i<n; i++) matsm5(z,1.0/w[i][i],i);
for (i=0; i<n; i++) {j=n-i-1; matxc5(z,j,ii[j]);}
}

/* matge5 - greatest element in the nth column of 5x5 matrix */

int matge5(p,n) double p[5][5]; int n; {double g, h; int i, m;
m=n;
g=p[n][n];
g=(g<0.0?-g:g);
for (i=n; i<5; i++) {
  h=p[i][n];
  h=(h<0.0?-h:h);
  if (h<g) continue;
  g=h; m=i;
  }
return m;
}

/* matcm5 - copy 5x5 matrix */

matcm5(z,x) double z[5][5], x[5][5]; {int i, j;
for (i=0; i<5; i++) for (j=0; j<5; j++) z[i][j]=x[i][j];}

/* matum5 - 5x5 unit matrix */

matum5(z) double z[5][5]; {int i, j;
for (i=0; i<5; i++) {
  for (j=0; j<5; j++) z[i][j]=0.0;
  z[i][i]=1.0;
  }
}

/* matxr5 - exchange ith and jth rows of a 5x5 matrix */

matxr5(z,i,j) double z[5][5]; int i, j; {int k; double t;
if (i==j) return;
for (k=0; k<5; k++) {t=z[i][k]; z[i][k]=z[j][k]; z[j][k]=t;}
}

/* matxc5 - exchange ith and jth columns of a 5x5 matrix */

matxc5(z,i,j) double z[5][5]; int i, j; {int k; double t;
if (i==j) return;
for (k=0; k<5; k++) {t=z[k][i]; z[k][i]=z[k][j]; z[k][j]=t;}
}

/* matac5 - augment column of a 5x5 matrix */

matac5(z,i,j,f,k) double z[5][5], f; int i, j, k; {int l;
for (l=0; l<5; l++) z[l][i]=z[l][j]+f*z[l][k];}

/* matsm5 - multiply ith column of 5x5 matrix by a factor */

matsm5(z,f,i) double z[5][5], f; int i; {int j;
for (j=0; j<5; j++) z[j][i]*=f;}

/* matome6 - "one minus epsilon" for iterative */
/*	     refinement of 5x5 inverse	       */

matome5(z,x) double z[5][5], x[5][5]; {int i, j;
for (i=0; i<5; i++)
for (j=0; j<5; j++)
  if (i==j) z[i][j]=2.0-x[i][j]; else z[i][j]=-x[i][j];
}

/* matmp5 - product of two 5x5 matrices */

matmp5(z,x,y) double z[5][5], x[5][5], y[5][5]; {
int i, j, k;
double u[5][5], v[5][5];
matcm5(u,x);
matcm5(v,y);
for (i=0; i<5; i++) for (j=0; j<5; j++) {
  z[i][j]=0.0;
  for (k=0; k<5; k++) z[i][j]+=u[i][k]*v[k][j];
  }
}

/* graph time sequence of probabilities */

tgraf(n,l) int n, l; {int i, j, fr; double s, ff;
if (n==0) return;
s=100.0/((double)AL);
asctobin();
for (i=0; i<n; i++) {
  for (fr=0, j=0; j<AL; j++) if (arr1[j]==1) fr++;
  ff=(double)fr;
  videodot(199-(int)(s*ff),BORG+i,(l==0?(i%2)+1:l));
  if (kbdst()) {kbdin(); break;}
  onegen(AL);
  }
}

/* generate self consistent totalistic frequencies */
/* r = percentage of special totalistic version	   */
/* running on a scale between totalistic and mean  */
/* field models.				   */

sctf(n,r) int n; double r; {
int i, j;
double e, p, q, s, t, y, em, en, dp;

gfram(CORG,0,n,3);
s=1.0-r;
en=(double)n;
dp=1.0/en;
em=(double)(TS-1);
for (p=0.0, j=0; j<n; p+=dp, j++) {
  q=1.0-p;
  sn[0]  = 1.0;
  sn[1]  = (1.0-r*(1.0-p*q)-s*q)/(q*(r*p+s/em));
  for (e=1.0, i=1; i<TS-1; e+=1.0, i++) {
    sn[i+1]  = ( 1.0 - r*(p*p+q*q) - s*(p*(e/em)+q*(1.0-e/em)) ) * sn[i];
    sn[i+1] -= p * (r*q + s*(1.0-(e-1.0)/em) ) * sn[i-1];
    sn[i+1] /= q*(r*p+s*((e+1.0)/em));
    }
  for (t=y=0.0, i=0; i<TS; i++) {
    t += sn[i];
    if (trule[i]=='1') y += sn[i];
    }
  videodot(199-j,CORG+(int)((100.0*y)/t),2);
  }
}

/* generate totalistic vector corresponding to probability p and */
/* totalistic character r. (r=0 is mean f., r=1 is totalistic)   */

tmvec(p,r) double p, r; {
int    i;
double e, q, s, em;
  q=1.0-p;
  s=1.0-r;
  em=(double)(TS-1);
  sn[0]  = 1.0;
  sn[1]  = (1.0-r*(1.0-p*q)-s*q)/(q*(r*p+s/em));
  for (e=1.0, i=1; i<TS-1; e+=1.0, i++) {
    sn[i+1]  = ( 1.0 - r*(p*p+q*q) - s*(p*(e/em)+q*(1.0-e/em)) ) * sn[i];
    sn[i+1] -= p * (r*q + s*(1.0-(e-1.0)/em) ) * sn[i-1];
    sn[i+1] /= q*(r*p+s*((e+1.0)/em));
    }
  for (e=0.0, i=0; i<TS; i++) e+=sn[i];
  for (i=0; i<TS; i++) sn[i]/=e;
}

/* option m, M					*/
/* "Monte Carlo" determination of probabilities */
/* n = mumber of generations			*/
/* l = color of dot				*/

moncar(n,l) int n, l; {
int i, j, k, b[KK], bb[KK][KK];
double bf[KK], bbf[KK][KK];
double a[KK], aa[KK], d[KK], el, en, t, tt, s;

clep('m');
gfram(BORG,0,100,3);
gdiag(BORG,0,100,2);
guare(BORG,0,100,2);
asctobin();
el=1.0/((double)AL);
en=1.0/((double)n);
for (i=0; i<KK; i++) {a[i]=0.0; aa[i]=0.0;}
for (k=0; k<n; k++) {
  onegen(AL);
  for (i=0; i<KK; i++) b[i]=0;
  for (i=0; i<AL; i++) b[arr1[i]]++;
  for (i=0; i<KK; i++) bf[i]=((double)(b[i]))*el;
  for (i=0; i<KK; i++) {a[i]+=bf[i]; aa[i]+=bf[i]*bf[i];}
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) bb[i][j]=0;
  for (i=1; i<AL; i++) bb[arr1[i-1]][arr1[i]]++;
  bb[arr1[AL-1]][arr1[0]]++; 
  for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
    bbf[i][j]=((double)(bb[i][j]))*el;
  videodot(199-(int)(100.0*bf[1]),BORG+(int)(100.0*bbf[1][1]),l);
  }
for (i=0; i<KK; i++) {a[i]*=en; aa[i]*=en;}
videocursor(0,BROW+1,0);
s=1.0/log((double)KK);
t=0.0; tt=0.0;
for (i=0; i<KK; i++) t+=bf[i]*log(bf[i]);
for (i=0; i<KK; i++) d[i]=sqrt(aa[i]-a[i]*a[i]);
for (i=0; i<KK; i++) for (j=0; j<KK; j++) tt+=bbf[i][j]*log(bbf[i][j]);
printf("(Monte Carlo) \n"); 
printf("lambda       = %5.3f\n",1.0-bf[0]);
printf("entropy      = %5.3f, pairs %5.3f\n",-t*s,-0.5*tt*s);
printf("\n");
if (n>1) printf("average      = %5.3f, %5.3f\n",a[0],a[1]);
if (n>1) printf("deviation    = %5.3f, %5.3f\n",d[0],d[1]);
printf("frequencies ");
for (i=0; i<KK; i++) printf("%2d:%5.3f ",i,bf[i]);
printf("\n");
for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
  printf("%1d%1d:%5.3f ",i,j,bbf[i][j]);
printf("\n");
}

/* option 'n' 						*/
/* empirical distribution of sums within a neighborhood */
/* ll - initial line					*/
/* mm - number of cells					*/
/* nn - number of lines					*/

neisum(ll,mm,nn) int ll, mm, nn; {
int ii, i, k, m, n, l, b[TS];
double f, em, en, bf[TS];

asctobin();
em=((double)(mm));
f=((double)YL)/((double)AL);
for (i=0; i<TS; i++) sm[i]=0.0;
k=0;
for (ii=0; ii<nn; ii++) {
  onegen(mm);
  onesum(mm,TS,b);
  for (i=0; i<TS; i++) bf[i]=((double)(b[i]));
  for (i=0; i<TS; i++) sm[i]+=bf[i];
  m=0; videodot(ll+ii,m++,3);
  for (i=0; i<TS; i++) {
    n=(int)(f*(bf[i]));
    if (n>0) for (l=0; l<n; l++) videodot(ll+ii,m++,i%2);
    }
  videodot(ll+ii,m++,3);
  k++;
  if (kbdst()) {kbdin(); break;}
  }  /* end for-ii */
  en=((double)(k));
  m=0; videodot(ll+nn,m++,3);
  for (i=0; i<TS; i++) {
    n=(int)(f*(sm[i]/en));
    if (n>0) for (l=0; l<n; l++) videodot(ll+nn,m++,i%2+1);
    }
  videodot(ll+nn,m++,3);
for (i=0; i<TS; i++) sm[i]/=en*em;
videocursor(0,BROW+7,0);
for (i=0; i<5; i++) printf("%1d:%5.3f ",i,sm[i]);
videocursor(0,BROW+8,0);
for (i=5; i<TS; i++) printf("%1d:%5.3f ",i,sm[i]);
}

/* option 'N'						*/
/* empirical distribution of sums within a neighborhood */
/* ll - initial line					*/
/* mm - number of cells					*/
/* nn - number of lines					*/

nbrsum(ll,mm,nn) int ll, mm, nn; {
int ii, jj, i, k, m, n, l, b[TS];
double f, em, en, kk, bf[TS];

asctobin();
em=((double)(mm));
en=((double)(nn));
f=((double)YL)/((double)AL);
for (i=0; i<TS; i++) sm[i]=0.0;
k=0;
for (jj=0; jj<nn; jj++) {
  for (i=0; i<TS; i++) bf[i]=0.0;
  for (ii=0; ii<nn; ii++) {
    onegen(mm);
    onesum(mm,TS,b);
    for (i=0; i<TS; i++) bf[i]+=((double)(b[i]));
    }  /* end for-ii */
  m=0; videodot(ll+jj,m++,3);
  for (i=0; i<TS; i++) {
    n=(int)(f*(bf[i]/en));
    if (n>0) for (l=0; l<n; l++) videodot(ll+jj,m++,i%2+1);
    }
  videodot(ll+jj,m++,3);
  for (i=0; i<TS; i++) sm[i]+=bf[i];
  k++;
  if (kbdst()) {kbdin(); break;}
  } /* end for-jj */
kk=((double)(k));
videodot(ll+jj,m++,3);
for (i=0; i<TS; i++) sm[i]/=kk*en*em;
videocursor(0,BROW+7,0);
for (i=0; i<5; i++) printf("%1d:%5.3f ",i,sm[i]);
videocursor(0,BROW+8,0);
for (i=5; i<TS; i++) printf("%1d:%5.3f ",i,sm[i]);
}

/* option '%' 						*/
/* empirical distribution of sums within a neighborhood */
/* ll - initial line					*/

neidif(ll) int ll; {int i, m, n, l; double f, p, r;

  p=smq();
  r=smq();
  tmvec(p,r);
  f=((double)YL);
  m=0; videodot(ll+5,m++,3);
  for (i=0; i<TS; i++) {
    n=(int)(f*sn[i]);
    if (n>0) for (l=0; l<n; l++) videodot(ll+5,m++,i%2+1);
    }
  videodot(ll+10,m++,3);
  m=0; videodot(ll+10,m++,3);
  for (i=0; i<TS; i++) {
    n=(int)(f*sm[i]);
    if (n>0) for (l=0; l<n; l++) videodot(ll+10,m++,i%2+1);
    }
  videodot(ll+10,m++,3);
videocursor(0,BROW+6,0);
for (i=0; i<5; i++) printf("%1d:%5.3f ",i,sm[i]-sn[i]);
videocursor(0,BROW+7,0);
for (i=5; i<TS; i++) printf("%1d:%5.3f ",i,sm[i]-sn[i]);
}

/* option 'K' 						*/
/* empirical distribution of sums within a neighborhood */

neicon() {int i, j, k, l; double a, p, r, s;

clep('a');
gfram(AORG,0,100,3);
for (p=0.01, i=1; i<100; p+=0.01, i++)
for (r=0.01, j=1; j<100; r+=0.01, j++) {
  tmvec(p,r);
  for (s=0.0, k=0; k<TS; k++) {a=sm[k]-sn[k]; s+=a*a;}
  s=sqrt(s);

    if (s<0.090) l=0; else
    if (s<0.111) {if((i+j)%2) l=0; else l=3;} else
    if (s<0.155) l=3; else
    if (s<0.222) {if((i+j)%2) l=3; else l=2;} else
    if (s<0.333) l=2; else
    if (s<0.550) {if((i+j)%2) l=2; else l=1;} else
    if (s<0.800) l=1; else
                  if((i+j)%2) l=1; else l=0;

    videodot(199-i,AORG+j,l);
  }
}

/* graph the probability of the second generation */

pdiff(n) int n; {
berncoef(bx);
gfram(CORG,0,n,3);
gdiag(CORG,0,n,3);
bgraf(CORG,0,2,n);
}

/* graph probabilities in time sequence */

ptseq(n) int n; {
gfram(BORG,0,n,3);
tgraf(100,0);
}

/* histogram of probabilities n points, color l */

hipro(n,l) int n, l; {
gfram(AORG,0,n,3);
cgraf(1000,l);
}

/* graph n points on the trajectory of w (mils), in color l */

traj(w,n,l) int w, n, l; {int i; double bern(), p, q;
berncoef(bx);
q=0.001*((double)w);
for (i=0; i<=n; i++) {
  p=q; q=bern(p,2);
  videodot(199-(int)(100.0*p),CORG+(int)(100.0*q),l);
  }
}

/* graph 100 iterates of the "critical point" w (mils)	*/
/* but start graphing after t steps (transient steps)	*/

trajy(w,t) int w; unsigned int t; {int i; double bern(), p, q;
berncoef(bx);
gfram(BORG,0,100);
q=0.001*((double)w);
if (t>0) for (i=0; i<t; i++) {p=q; q=bern(p,2);}
for (i=0; i<=100; i++) {
  p=q; q=bern(p,2);
  videodot(199-(int)(100.0*q),BORG+i,1);
  }
}

/* graph the iterated probability of the second generation */

pidiff(n) int n; {int i; double bern(), en, p;
en=1.0/((double)(n));
berncoef(bx);
gdiag(CORG,0,n,3);
for (i=0; i<=n; i++) {
  p=((double)(i))*en;
  videodot(199-(int)(100.0*p),CORG+(int)(100.0*bern(bern(p,2),2)),3);
  }
}

/* graph the twice iterated probability of the second generation */

pjdiff(n) int n; {int i; double bern(), en, p;
en=1.0/((double)(n));
berncoef(bx);
gdiag(CORG,0,n,3);
for (i=0; i<=n; i++) {
  p=((double)(i))*en;
  videodot(199-(int)(100.0*p),CORG+(int)(100.0*bern(bern(bern(p,2),2),2)),2);
  }
}

/* graph the thrice iterated probability of the third generation */

pkdiff(n) int n; {int i; double bern(), en, p;
en=1.0/((double)(n));
berncoef(bx);
gdiag(CORG,0,n,3);
for (i=0; i<=n; i++) {
  p=((double)(i))*en;
  videodot(199-(int)(100.0*p),CORG+(int)(100.0*bern(bern(bern(bern(p,2),2),2),2)),3);
  }
}

/* graph the quadruply iterated probability of the fourth generation */

pldiff(n) int n; {int i; double bern(), en, p, s;
en=1.0/((double)(n));
berncoef(bx);
gdiag(CORG,0,n,3);
for (i=0; i<=n; i++) {
  p=((double)(i))*en;
  s=bern(bern(bern(bern(bern(p,2),2),2),2),2);
  videodot(199-(int)(100.0*p),CORG+(int)(100.0*s),3);
  }
}

/* graph the probability of the third generation */

pdiff3(n) int n; {
bernthrd();
gfram(CORG,0,n,3);
gdiag(CORG,0,n,3);
bgraf(CORG,0,3,n);
}

/* display state frequencies in arr1 as a point on probability graph */
/* n = number of points to plot					     */
/* g = number of elapsed generations				     */
/* l = color of plotted point					     */

lifreq(n,g,l) int n, g, l; {
int     i,  j, os, ns;
double of, nf, s;

s=100.0/((double)AL);
asctobin();
for (i=0; i<n; i++) {
  os=0; ns=0;
  for (j=0; j<AL; j++) if (arr1[j]==1) os++;
  for (j=0; j<g;  j++) onegen(AL);
  for (j=0; j<AL; j++) if (arr1[j]==1) ns++;
  of=(double)os;
  nf=(double)ns;
  videodot(199-(int)(s*of),CORG+(int)(s*nf),l);
  }
}

/* end */

